/*-
 * Copyright (c) 2001-2002 Andrey Simonenko
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *   @(#)$Id: kip6fw.h,v 1.3.2.3 2002/09/24 10:52:30 simon Exp $
 */


#ifndef IPA_KIP6FW_H
#define IPA_KIP6FW_H

#include <osreldate.h>
#include <sys/types.h>

/*
 * There were bugs in IPv6 Firewall implementation since FreeBSD 4.0-RELEASE (?)
 * and ipa(8) started to work correctly with IPv6 Firewall after
 * FreeBSD 4.2-RELEASE, when those bugs were fixed.
 */

#if ((__FreeBSD_version >= 420001) || defined(USE_IP6FW)) && !defined(NO_IP6FW)

#ifndef USE_FreeBSD_IP6FW
# define USE_FreeBSD_IP6FW
#endif

#include <sys/types.h>
#include <sys/queue.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/ip6.h>
#include <netinet6/ip6_fw.h>

extern u_quad_t		kip6fw_bcnt_max;
extern struct ip6_fw	*kip6fw;
extern u_int		nkip6fw;

extern int	kip6fw_init(void);
extern void	kip6fw_close(void);
extern int	kip6fw_read_table(void);

		
#endif /* USE_FreeBSD_IP6FW */

#endif /* IPA_KIP6FW_H */
